# verwenden im tcl-script: "source [diesesFile]" oder ". [diesesFile]"
# source [file join [file dirname [info script]] collect_form.tcl]

# -------------------------------------------------------------------------

proc COLLECT_FORM {} {
  global form env
  
  if [info exists env(CONTENT_LENGTH)] {
    set forminput [read stdin $env(CONTENT_LENGTH)]
    set form(method) POST
  }
  
  if { [info exists env(QUERY_STRING)]  &&  $env(QUERY_STRING) != "" } {
    set forminput $env(QUERY_STRING)
    set form(method) GET
  }
  
  if [info exists form(method)] {
    foreach {name value} [split $forminput =&] {
      regsub -all \\\+ $value " " value
      regsub -all -nocase {%([0-9a-f][0-9a-f])} $value \
      {[format %c 0x\1]} value
      set form($name) [subst $value]
###puts "form($name)='$value'<br>"
    }
  }
}

# -------------------------------------------------------------------------

### COLLECT_FORM


# --- falls als shell-Script mit Parametern aufgerufen: ---
# --- script.tcl param1=val1 param2=val2 ...
foreach param $argv { foreach {key val} [split $param "="] {
  set form($key) $val
} }
  

# https://www.tcl.tk/man/tcl8.4/TclCmd/array.htm

# foreach {key val} [array get form] {
#   puts "<!-- form($key): '$val' -->"
# }

# --- sortiert: ---
# foreach key [lsort [array names form]] { puts "<!-- form($key): '$form($key)' -->" }
