#
# verwenden im tcl-script: "source [diesesFile]" oder ". [diesesFile]"
# source [file join [file dirname [info script]] proc_htmlEntitaeten.tcl]
#
# -------------------------------------------------------------------------
#
# Quelle: https://gist.github.com/ricardobeat/1216657
#
# Ermoeglicht es, u.a. Sonderzeichen so umzuwandeln,
# dass man sie in eine Internet-Adresse einfuegen kann
# s. auch: http://www.andre-jochim.de/url-encode.htm
#
# --- Beispiel: ---
# /media/sd-mmcblk0/eser/www # tclsh
# % source proc_urlencode.tcl
# % puts [uencode "?"]
# %3f
# % puts [udecode "%3f"]
# ?
# % exit
#

proc ue_init {} {
  lappend d + { }
  for {set i 0} {$i < 256} {incr i} {
    set c [format %c $i]
    set x %[format %02x $i]
    if {![string match {[a-zA-Z0-9]} $c]} {
      lappend e $c $x
      lappend d $x $c
    }
  }
  set ::ue_map $e
  set ::ud_map $d
}
ue_init

proc uencode {s} { string map $::ue_map $s }
proc udecode {s} { string map $::ud_map $s }

# ---

proc decode_printables { s } {
  # --- https://de.wikipedia.org/wiki/URL-Encoding
  # --- s. Tabelle "Relevante ASCII-Zeichen in Prozentdarstellung"
  string map -nocase {
    "%2d"      "-"
    "%2f"      "/"
    "%2e"      "."
    "%5f"      "_"
  } $s
}
